
/*
 *
 *    OPEN-XCHANGE legal information
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *
 *    In some countries OX, OX Open-Xchange, open xchange and OXtender
 *    as well as the corresponding Logos OX Open-Xchange and OX are registered
 *    trademarks.
 *    The use of the Logos is not covered by the GNU General Public License.
 *    Instead, you are allowed to use these Logos according to the terms and
 *    conditions of the Creative Commons License, Version 2.5, Attribution,
 *    Non-commercial, ShareAlike, and the interpretation of the term
 *    Non-commercial applicable to the aforementioned license is published
 *    on the web site http://www.open-xchange.com/EN/legal/index.html.
 *
 *    Please make sure that third-party modules and libraries are used
 *    according to their respective licenses.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original and derivative code shall remain
 *    under the copyright of the copyright holder(s) and/or original author(s)per
 *    the Attribution and Assignment Agreement that can be located at
 *    http://www.open-xchange.com/EN/developer/. The contributing author shall be
 *    given Attribution for the derivative code and a license granting use.
 *
 *     Copyright (C) 2016 OX Software GmbH
 *     Mail: info@open-xchange.com
 *
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License, Version 2 as published
 *     by the Free Software Foundation.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

package org.docx4j.dml.chartex2014;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlElementDecl;
import javax.xml.bind.annotation.XmlRegistry;
import javax.xml.namespace.QName;


/**
 * This object contains factory methods for each 
 * Java content interface and Java element interface 
 * generated in the com.microsoft.schemas.office.drawing._2014.chartex package. 
 * <p>An ObjectFactory allows you to programatically 
 * construct new instances of the Java representation 
 * for XML content. The Java representation of XML 
 * content can consist of schema derived interfaces 
 * and classes representing the binding of schema 
 * type definitions, element declarations and model 
 * groups.  Factory methods for each of these are 
 * provided in this class.
 * 
 */
@XmlRegistry
public class ObjectFactory {

    private final static QName _Chart_QNAME = new QName("http://schemas.microsoft.com/office/drawing/2014/chartex", "chart");
    private final static QName _ChartSpace_QNAME = new QName("http://schemas.microsoft.com/office/drawing/2014/chartex", "chartSpace");
    private final static QName _CTNumericDimensionNf_QNAME = new QName("http://schemas.microsoft.com/office/drawing/2014/chartex", "nf");
    private final static QName _CTNumericDimensionF_QNAME = new QName("http://schemas.microsoft.com/office/drawing/2014/chartex", "f");
    private final static QName _CTNumericDimensionLvl_QNAME = new QName("http://schemas.microsoft.com/office/drawing/2014/chartex", "lvl");
    private final static QName _CTTextDataV_QNAME = new QName("http://schemas.microsoft.com/office/drawing/2014/chartex", "v");

    /**
     * Create a new ObjectFactory that can be used to create new instances of schema derived classes for package: com.microsoft.schemas.office.drawing._2014.chartex
     * 
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link CTChartSpace }
     * 
     */
    public CTChartSpace createCTChartSpace() {
        return new CTChartSpace();
    }

    /**
     * Create an instance of {@link CTRelId }
     * 
     */
    public CTRelId createCTRelId() {
        return new CTRelId();
    }

    /**
     * Create an instance of {@link CTGeoData }
     * 
     */
    public CTGeoData createCTGeoData() {
        return new CTGeoData();
    }

    /**
     * Create an instance of {@link CTGeoLocationQuery }
     * 
     */
    public CTGeoLocationQuery createCTGeoLocationQuery() {
        return new CTGeoLocationQuery();
    }

    /**
     * Create an instance of {@link CTGeoChildEntitiesQueryResult }
     * 
     */
    public CTGeoChildEntitiesQueryResult createCTGeoChildEntitiesQueryResult() {
        return new CTGeoChildEntitiesQueryResult();
    }

    /**
     * Create an instance of {@link CTDataLabelHidden }
     * 
     */
    public CTDataLabelHidden createCTDataLabelHidden() {
        return new CTDataLabelHidden();
    }

    /**
     * Create an instance of {@link CTHeaderFooter }
     * 
     */
    public CTHeaderFooter createCTHeaderFooter() {
        return new CTHeaderFooter();
    }

    /**
     * Create an instance of {@link CTChart }
     * 
     */
    public CTChart createCTChart() {
        return new CTChart();
    }

    /**
     * Create an instance of {@link CTGeoChildEntitiesQueryResults }
     * 
     */
    public CTGeoChildEntitiesQueryResults createCTGeoChildEntitiesQueryResults() {
        return new CTGeoChildEntitiesQueryResults();
    }

    /**
     * Create an instance of {@link CTAddress }
     * 
     */
    public CTAddress createCTAddress() {
        return new CTAddress();
    }

    /**
     * Create an instance of {@link CTGeoLocation }
     * 
     */
    public CTGeoLocation createCTGeoLocation() {
        return new CTGeoLocation();
    }

    /**
     * Create an instance of {@link CTLegend }
     * 
     */
    public CTLegend createCTLegend() {
        return new CTLegend();
    }

    /**
     * Create an instance of {@link CTCopyrights }
     * 
     */
    public CTCopyrights createCTCopyrights() {
        return new CTCopyrights();
    }

    /**
     * Create an instance of {@link CTStringValue }
     * 
     */
    public CTStringValue createCTStringValue() {
        return new CTStringValue();
    }

    /**
     * Create an instance of {@link CTParentLabelLayout }
     * 
     */
    public CTParentLabelLayout createCTParentLabelLayout() {
        return new CTParentLabelLayout();
    }

    /**
     * Create an instance of {@link CTDataPoint }
     * 
     */
    public CTDataPoint createCTDataPoint() {
        return new CTDataPoint();
    }

    /**
     * Create an instance of {@link CTGeoHierarchyEntity }
     * 
     */
    public CTGeoHierarchyEntity createCTGeoHierarchyEntity() {
        return new CTGeoHierarchyEntity();
    }

    /**
     * Create an instance of {@link CTNumberColorPosition }
     * 
     */
    public CTNumberColorPosition createCTNumberColorPosition() {
        return new CTNumberColorPosition();
    }

    /**
     * Create an instance of {@link CTData }
     * 
     */
    public CTData createCTData() {
        return new CTData();
    }

    /**
     * Create an instance of {@link CTGeoDataEntityQueryResult }
     * 
     */
    public CTGeoDataEntityQueryResult createCTGeoDataEntityQueryResult() {
        return new CTGeoDataEntityQueryResult();
    }

    /**
     * Create an instance of {@link CTGeoCache }
     * 
     */
    public CTGeoCache createCTGeoCache() {
        return new CTGeoCache();
    }

    /**
     * Create an instance of {@link CTAxis }
     * 
     */
    public CTAxis createCTAxis() {
        return new CTAxis();
    }

    /**
     * Create an instance of {@link CTStringLevel }
     * 
     */
    public CTStringLevel createCTStringLevel() {
        return new CTStringLevel();
    }

    /**
     * Create an instance of {@link CTGridlines }
     * 
     */
    public CTGridlines createCTGridlines() {
        return new CTGridlines();
    }

    /**
     * Create an instance of {@link CTBinning }
     * 
     */
    public CTBinning createCTBinning() {
        return new CTBinning();
    }

    /**
     * Create an instance of {@link CTExtensionList }
     * 
     */
    public CTExtensionList createCTExtensionList() {
        return new CTExtensionList();
    }

    /**
     * Create an instance of {@link CTChartData }
     * 
     */
    public CTChartData createCTChartData() {
        return new CTChartData();
    }

    /**
     * Create an instance of {@link CTGeoDataPointToEntityQueryResults }
     * 
     */
    public CTGeoDataPointToEntityQueryResults createCTGeoDataPointToEntityQueryResults() {
        return new CTGeoDataPointToEntityQueryResults();
    }

    /**
     * Create an instance of {@link CTGeoDataPointToEntityQueryResult }
     * 
     */
    public CTGeoDataPointToEntityQueryResult createCTGeoDataPointToEntityQueryResult() {
        return new CTGeoDataPointToEntityQueryResult();
    }

    /**
     * Create an instance of {@link CTValueColorEndPosition }
     * 
     */
    public CTValueColorEndPosition createCTValueColorEndPosition() {
        return new CTValueColorEndPosition();
    }

    /**
     * Create an instance of {@link CTNumericLevel }
     * 
     */
    public CTNumericLevel createCTNumericLevel() {
        return new CTNumericLevel();
    }

    /**
     * Create an instance of {@link CTFormatOverride }
     * 
     */
    public CTFormatOverride createCTFormatOverride() {
        return new CTFormatOverride();
    }

    /**
     * Create an instance of {@link CTExtension }
     * 
     */
    public CTExtension createCTExtension() {
        return new CTExtension();
    }

    /**
     * Create an instance of {@link CTExtremeValueColorPosition }
     * 
     */
    public CTExtremeValueColorPosition createCTExtremeValueColorPosition() {
        return new CTExtremeValueColorPosition();
    }

    /**
     * Create an instance of {@link CTFormula }
     * 
     */
    public CTFormula createCTFormula() {
        return new CTFormula();
    }

    /**
     * Create an instance of {@link CTGeoChildEntities }
     * 
     */
    public CTGeoChildEntities createCTGeoChildEntities() {
        return new CTGeoChildEntities();
    }

    /**
     * Create an instance of {@link CTStatistics }
     * 
     */
    public CTStatistics createCTStatistics() {
        return new CTStatistics();
    }

    /**
     * Create an instance of {@link CTGeoLocations }
     * 
     */
    public CTGeoLocations createCTGeoLocations() {
        return new CTGeoLocations();
    }

    /**
     * Create an instance of {@link CTAggregation }
     * 
     */
    public CTAggregation createCTAggregation() {
        return new CTAggregation();
    }

    /**
     * Create an instance of {@link CTPlotSurface }
     * 
     */
    public CTPlotSurface createCTPlotSurface() {
        return new CTPlotSurface();
    }

    /**
     * Create an instance of {@link CTDataLabel }
     * 
     */
    public CTDataLabel createCTDataLabel() {
        return new CTDataLabel();
    }

    /**
     * Create an instance of {@link CTStringDimension }
     * 
     */
    public CTStringDimension createCTStringDimension() {
        return new CTStringDimension();
    }

    /**
     * Create an instance of {@link CTSeries }
     * 
     */
    public CTSeries createCTSeries() {
        return new CTSeries();
    }

    /**
     * Create an instance of {@link CTTickLabels }
     * 
     */
    public CTTickLabels createCTTickLabels() {
        return new CTTickLabels();
    }

    /**
     * Create an instance of {@link CTPlotAreaRegion }
     * 
     */
    public CTPlotAreaRegion createCTPlotAreaRegion() {
        return new CTPlotAreaRegion();
    }

    /**
     * Create an instance of {@link CTValueColors }
     * 
     */
    public CTValueColors createCTValueColors() {
        return new CTValueColors();
    }

    /**
     * Create an instance of {@link CTGeoChildTypes }
     * 
     */
    public CTGeoChildTypes createCTGeoChildTypes() {
        return new CTGeoChildTypes();
    }

    /**
     * Create an instance of {@link CTSeriesElementVisibilities }
     * 
     */
    public CTSeriesElementVisibilities createCTSeriesElementVisibilities() {
        return new CTSeriesElementVisibilities();
    }

    /**
     * Create an instance of {@link CTGeoDataEntityQuery }
     * 
     */
    public CTGeoDataEntityQuery createCTGeoDataEntityQuery() {
        return new CTGeoDataEntityQuery();
    }

    /**
     * Create an instance of {@link CTGeoLocationQueryResult }
     * 
     */
    public CTGeoLocationQueryResult createCTGeoLocationQueryResult() {
        return new CTGeoLocationQueryResult();
    }

    /**
     * Create an instance of {@link CTGeoPolygons }
     * 
     */
    public CTGeoPolygons createCTGeoPolygons() {
        return new CTGeoPolygons();
    }

    /**
     * Create an instance of {@link CTTickMarks }
     * 
     */
    public CTTickMarks createCTTickMarks() {
        return new CTTickMarks();
    }

    /**
     * Create an instance of {@link CTText }
     * 
     */
    public CTText createCTText() {
        return new CTText();
    }

    /**
     * Create an instance of {@link CTGeoChildEntitiesQuery }
     * 
     */
    public CTGeoChildEntitiesQuery createCTGeoChildEntitiesQuery() {
        return new CTGeoChildEntitiesQuery();
    }

    /**
     * Create an instance of {@link CTValueAxisScaling }
     * 
     */
    public CTValueAxisScaling createCTValueAxisScaling() {
        return new CTValueAxisScaling();
    }

    /**
     * Create an instance of {@link CTAxisUnits }
     * 
     */
    public CTAxisUnits createCTAxisUnits() {
        return new CTAxisUnits();
    }

    /**
     * Create an instance of {@link CTClear }
     * 
     */
    public CTClear createCTClear() {
        return new CTClear();
    }

    /**
     * Create an instance of {@link CTGeography }
     * 
     */
    public CTGeography createCTGeography() {
        return new CTGeography();
    }

    /**
     * Create an instance of {@link CTDataLabels }
     * 
     */
    public CTDataLabels createCTDataLabels() {
        return new CTDataLabels();
    }

    /**
     * Create an instance of {@link CTGeoPolygon }
     * 
     */
    public CTGeoPolygon createCTGeoPolygon() {
        return new CTGeoPolygon();
    }

    /**
     * Create an instance of {@link CTValueColorPositions }
     * 
     */
    public CTValueColorPositions createCTValueColorPositions() {
        return new CTValueColorPositions();
    }

    /**
     * Create an instance of {@link CTExternalData }
     * 
     */
    public CTExternalData createCTExternalData() {
        return new CTExternalData();
    }

    /**
     * Create an instance of {@link CTGeoDataPointToEntityQuery }
     * 
     */
    public CTGeoDataPointToEntityQuery createCTGeoDataPointToEntityQuery() {
        return new CTGeoDataPointToEntityQuery();
    }

    /**
     * Create an instance of {@link CTGeoLocationQueryResults }
     * 
     */
    public CTGeoLocationQueryResults createCTGeoLocationQueryResults() {
        return new CTGeoLocationQueryResults();
    }

    /**
     * Create an instance of {@link CTPrintSettings }
     * 
     */
    public CTPrintSettings createCTPrintSettings() {
        return new CTPrintSettings();
    }

    /**
     * Create an instance of {@link CTDataId }
     * 
     */
    public CTDataId createCTDataId() {
        return new CTDataId();
    }

    /**
     * Create an instance of {@link CTGeoDataPointQuery }
     * 
     */
    public CTGeoDataPointQuery createCTGeoDataPointQuery() {
        return new CTGeoDataPointQuery();
    }

    /**
     * Create an instance of {@link CTSubtotals }
     * 
     */
    public CTSubtotals createCTSubtotals() {
        return new CTSubtotals();
    }

    /**
     * Create an instance of {@link CTAxisUnitsLabel }
     * 
     */
    public CTAxisUnitsLabel createCTAxisUnitsLabel() {
        return new CTAxisUnitsLabel();
    }

    /**
     * Create an instance of {@link CTNumericDimension }
     * 
     */
    public CTNumericDimension createCTNumericDimension() {
        return new CTNumericDimension();
    }

    /**
     * Create an instance of {@link CTPageMargins }
     * 
     */
    public CTPageMargins createCTPageMargins() {
        return new CTPageMargins();
    }

    /**
     * Create an instance of {@link CTSeriesLayoutProperties }
     * 
     */
    public CTSeriesLayoutProperties createCTSeriesLayoutProperties() {
        return new CTSeriesLayoutProperties();
    }

    /**
     * Create an instance of {@link CTNumericValue }
     * 
     */
    public CTNumericValue createCTNumericValue() {
        return new CTNumericValue();
    }

    /**
     * Create an instance of {@link CTNumberFormat }
     * 
     */
    public CTNumberFormat createCTNumberFormat() {
        return new CTNumberFormat();
    }

    /**
     * Create an instance of {@link CTChartTitle }
     * 
     */
    public CTChartTitle createCTChartTitle() {
        return new CTChartTitle();
    }

    /**
     * Create an instance of {@link CTFormatOverrides }
     * 
     */
    public CTFormatOverrides createCTFormatOverrides() {
        return new CTFormatOverrides();
    }

    /**
     * Create an instance of {@link CTRegionLabelLayout }
     * 
     */
    public CTRegionLabelLayout createCTRegionLabelLayout() {
        return new CTRegionLabelLayout();
    }

    /**
     * Create an instance of {@link CTCategoryAxisScaling }
     * 
     */
    public CTCategoryAxisScaling createCTCategoryAxisScaling() {
        return new CTCategoryAxisScaling();
    }

    /**
     * Create an instance of {@link CTValueColorMiddlePosition }
     * 
     */
    public CTValueColorMiddlePosition createCTValueColorMiddlePosition() {
        return new CTValueColorMiddlePosition();
    }

    /**
     * Create an instance of {@link CTDataLabelVisibilities }
     * 
     */
    public CTDataLabelVisibilities createCTDataLabelVisibilities() {
        return new CTDataLabelVisibilities();
    }

    /**
     * Create an instance of {@link CTGeoDataEntityQueryResults }
     * 
     */
    public CTGeoDataEntityQueryResults createCTGeoDataEntityQueryResults() {
        return new CTGeoDataEntityQueryResults();
    }

    /**
     * Create an instance of {@link CTPercentageColorPosition }
     * 
     */
    public CTPercentageColorPosition createCTPercentageColorPosition() {
        return new CTPercentageColorPosition();
    }

    /**
     * Create an instance of {@link CTAxisTitle }
     * 
     */
    public CTAxisTitle createCTAxisTitle() {
        return new CTAxisTitle();
    }

    /**
     * Create an instance of {@link CTPageSetup }
     * 
     */
    public CTPageSetup createCTPageSetup() {
        return new CTPageSetup();
    }

    /**
     * Create an instance of {@link CTTextData }
     * 
     */
    public CTTextData createCTTextData() {
        return new CTTextData();
    }

    /**
     * Create an instance of {@link CTPlotArea }
     * 
     */
    public CTPlotArea createCTPlotArea() {
        return new CTPlotArea();
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRelId }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://schemas.microsoft.com/office/drawing/2014/chartex", name = "chart")
    public JAXBElement<CTRelId> createChart(CTRelId value) {
        return new JAXBElement<CTRelId>(_Chart_QNAME, CTRelId.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTChartSpace }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://schemas.microsoft.com/office/drawing/2014/chartex", name = "chartSpace")
    public JAXBElement<CTChartSpace> createChartSpace(CTChartSpace value) {
        return new JAXBElement<CTChartSpace>(_ChartSpace_QNAME, CTChartSpace.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFormula }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://schemas.microsoft.com/office/drawing/2014/chartex", name = "nf", scope = CTNumericDimension.class)
    public JAXBElement<CTFormula> createCTNumericDimensionNf(CTFormula value) {
        return new JAXBElement<CTFormula>(_CTNumericDimensionNf_QNAME, CTFormula.class, CTNumericDimension.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFormula }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://schemas.microsoft.com/office/drawing/2014/chartex", name = "f", scope = CTNumericDimension.class)
    public JAXBElement<CTFormula> createCTNumericDimensionF(CTFormula value) {
        return new JAXBElement<CTFormula>(_CTNumericDimensionF_QNAME, CTFormula.class, CTNumericDimension.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTNumericLevel }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://schemas.microsoft.com/office/drawing/2014/chartex", name = "lvl", scope = CTNumericDimension.class)
    public JAXBElement<CTNumericLevel> createCTNumericDimensionLvl(CTNumericLevel value) {
        return new JAXBElement<CTNumericLevel>(_CTNumericDimensionLvl_QNAME, CTNumericLevel.class, CTNumericDimension.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFormula }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://schemas.microsoft.com/office/drawing/2014/chartex", name = "f", scope = CTTextData.class)
    public JAXBElement<CTFormula> createCTTextDataF(CTFormula value) {
        return new JAXBElement<CTFormula>(_CTNumericDimensionF_QNAME, CTFormula.class, CTTextData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link String }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://schemas.microsoft.com/office/drawing/2014/chartex", name = "v", scope = CTTextData.class)
    public JAXBElement<String> createCTTextDataV(String value) {
        return new JAXBElement<String>(_CTTextDataV_QNAME, String.class, CTTextData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFormula }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://schemas.microsoft.com/office/drawing/2014/chartex", name = "nf", scope = CTStringDimension.class)
    public JAXBElement<CTFormula> createCTStringDimensionNf(CTFormula value) {
        return new JAXBElement<CTFormula>(_CTNumericDimensionNf_QNAME, CTFormula.class, CTStringDimension.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFormula }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://schemas.microsoft.com/office/drawing/2014/chartex", name = "f", scope = CTStringDimension.class)
    public JAXBElement<CTFormula> createCTStringDimensionF(CTFormula value) {
        return new JAXBElement<CTFormula>(_CTNumericDimensionF_QNAME, CTFormula.class, CTStringDimension.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTStringLevel }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://schemas.microsoft.com/office/drawing/2014/chartex", name = "lvl", scope = CTStringDimension.class)
    public JAXBElement<CTStringLevel> createCTStringDimensionLvl(CTStringLevel value) {
        return new JAXBElement<CTStringLevel>(_CTNumericDimensionLvl_QNAME, CTStringLevel.class, CTStringDimension.class, value);
    }

}
